# MySQL dump 8.8
#
# Host: localhost    Database: OpenReference
#--------------------------------------------------------
# Server version	3.23.23-beta

#
# Table structure for table 'Category'
#

CREATE TABLE Category (
  Category.CategoryID bigint(20) DEFAULT '0' NOT NULL,
  Category.Name varchar(80) DEFAULT '' NOT NULL,
  Category.OrderWeight float(10,2) DEFAULT '0.00' NOT NULL,
  Category.ParentCategory bigint(20) DEFAULT '0' NOT NULL
)/*! type=MyISAM */;

#
# Table structure for table 'CategoryReference'
#

CREATE TABLE CategoryReference (
  CategoryReference.CategoryID bigint(20) DEFAULT '0' NOT NULL,
  CategoryReference.ReferenceID bigint(20) DEFAULT '0' NOT NULL
)/*! type=MyISAM */;

#
# Table structure for table 'Reference'
#
# The View field takes "AllUsers", "Myself", and "UserList"

CREATE TABLE Reference (
  Reference.ReferenceID bigint(20) DEFAULT '0' NOT NULL,
  Reference.UserID bigint(20) DEFAULT '0' NOT NULL,
  Reference.PostDate datetime DEFAULT '0000-00-00 00:00:00' NOT NULL,
  Reference.URL text DEFAULT '' NOT NULL,
  Reference.Name text,
  Reference.Author text,
  Reference.Memo MEDIUMTEXT,
  Reference.BibCode text,
  Reference.View varchar(20) DEFAULT 'AllUsers' NOT NULL,
  Reference.UserList text
)/*! type=MyISAM */;

CREATE TABLE Comment (
  Comment.CommentID bigint(20) DEFAULT '0' NOT NULL,
  Comment.UserID bigint(20) DEFAULT '0' NOT NULL,
  Comment.ReferenceID bigint(20) DEFAULT '0' NOT NULL,
  Comment.FatherCommentID bigint(20) DEFAULT '0' NOT NULL,
  Comment.NumberOfChildren int(10) DEFAULT '0' NOT NULL,
  Comment.CommentSubject text,
  Comment.Comment text
)/*! type=MyISAM */;

#
# Table structure for table 'User'
#
# The View field takes "AllUsers", "Myself", and "UserList"

CREATE TABLE User (
  User.UserID bigint(20) DEFAULT '0' NOT NULL,
  User.Username varchar(40) DEFAULT '' NOT NULL,
  User.Password varchar(40) DEFAULT '' NOT NULL,
  User.FirstName varchar(40),
  User.LastName varchar(40),
  User.Email varchar(40),
  User.Phone varchar(40),
  User.View varchar(20) DEFAULT 'AllUsers' NOT NULL,
  User.UserList text
)/*! type=MyISAM */;

INSERT INTO Category (CategoryID, Name, OrderWeight, ParentCategory )
VALUES ('-1', 'root', '0', '-2');

INSERT INTO User (UserID, Username, Password, FirstName, LastName, Email,
Phone, View, UserList )
VALUES ('-1', 'anonymous', 'mypass', 'Anonymous', 'Coward',
'anonymous@anonymous', '800-555-5555', 'AllUsers', NULL);

