// Usage: "java consolidate_fields DB_NAME username password"
// It will consolidate all text fields into memo field for
// newer OpenReference 

import java.sql.*;
import java.net.*;
import java.util.*;
import java.io.*;

public class consolidate_fields {

  public static void main (String[] args) throws Exception {

    System.out.println(args[0] + " " + args[1] + " " + args[2]);

    String DRIVER = "org.gjt.mm.mysql.Driver";
    String URL = "jdbc:mysql://localhost/" + args[0];
    String USER = args[1];
    String PASSWORD = args[2];

    Connection conn;

    try {
      // explicitly register/load the given JDBC driver
      Class.forName(DRIVER);
    } catch (ClassNotFoundException e) {
      System.err.println("Failed to load DBC driver: " + DRIVER);
      System.err.println(e.getMessage());
      return;
    }

    try {
      // establish a connection to the given database URL
      conn = DriverManager.getConnection(URL, USER, PASSWORD);
    } catch (SQLException e) {
      System.err.println("Failed to connect to JDBC driver:" + URL);
      System.out.println("\n--- SQLException caught ---\n");
      while (e != null) {
        System.out.println("Message:   " + e.getMessage ());
        System.out.println("SQLState:  " + e.getSQLState ());
        System.out.println("ErrorCode: " + e.getErrorCode ());
        e = e.getNextException();
        System.out.println("");
      }
      return;
    }
    String SQLstr = "SELECT * FROM Reference";
    Statement stmt = conn.createStatement();
    ResultSet rs = stmt.executeQuery(SQLstr);
    stmt.close();

    String UpdateString;
    while (rs.next()) {
      System.out.println("reference number: " + rs.getString("ReferenceID") );
      UpdateString = rs.getString("Memo");
      if ( UpdateString == null ) UpdateString = " ";
      if ( rs.getString("Citation") != null ) {
        UpdateString = UpdateString + "\n<p><b>Citation</b><p> " + rs.getString("Citation");
      }
      if ( rs.getString("Keywords") != null ) {
        UpdateString = UpdateString + "\n<p><b>Keywords</b><p> " + rs.getString("Keywords");
      }
      if ( rs.getString("Purpose") != null ) {
        UpdateString = UpdateString + "\n<p><b>Purpose</b><p> " + rs.getString("Purpose");
      }
      if ( rs.getString("Theory") != null ) {
        UpdateString = UpdateString + "\n<p><b>Theory</b><p> " + rs.getString("Theory");
      }
      if ( rs.getString("Method") != null ) {
        UpdateString = UpdateString + "\n<p><b>Method</b><p> " + rs.getString("Method");
      }
      if ( rs.getString("Summary") != null ) {
        UpdateString = UpdateString + "\n<p><b>Summary</b><p> " + rs.getString("Summary");
      }
      if ( rs.getString("Contribution") != null ) {
        UpdateString = UpdateString + "\n<p><b>Contribution</b><p> " + rs.getString("Contribution");
      }
      if ( rs.getString("StrengthWeakness") != null ) {
        UpdateString = UpdateString + "\n<p><b>StrengthWeakness</b><p> " + rs.getString("StrengthWeakness");
      }
      if ( rs.getString("Critique") != null ) {
        UpdateString = UpdateString + "\n<p><b>Critique</b><p> " + rs.getString("Critique");
      }

      UpdateString = escapeString( UpdateString );
      stmt = conn.createStatement();
      SQLstr = "UPDATE Reference SET Memo = \'" + UpdateString + "\' WHERE ReferenceID = " + rs.getString("ReferenceID");
//System.out.println( SQLstr );
      stmt.executeUpdate( SQLstr );    
      stmt.close();
    }

    // delete excessive fields
    stmt = conn.createStatement();
    SQLstr = "ALTER TABLE Reference DROP COLUMN Citation";
    stmt.executeUpdate( SQLstr );
    SQLstr = "ALTER TABLE Reference DROP COLUMN Keywords";
    stmt.executeUpdate( SQLstr );
    SQLstr = "ALTER TABLE Reference DROP COLUMN Purpose";
    stmt.executeUpdate( SQLstr );
    SQLstr = "ALTER TABLE Reference DROP COLUMN Theory";
    stmt.executeUpdate( SQLstr );
    SQLstr = "ALTER TABLE Reference DROP COLUMN Method";
    stmt.executeUpdate( SQLstr );
    SQLstr = "ALTER TABLE Reference DROP COLUMN Summary";
    stmt.executeUpdate( SQLstr );
    SQLstr = "ALTER TABLE Reference DROP COLUMN Contribution";
    stmt.executeUpdate( SQLstr );
    SQLstr = "ALTER TABLE Reference DROP COLUMN StrengthWeakness";
    stmt.executeUpdate( SQLstr );
    SQLstr = "ALTER TABLE Reference DROP COLUMN Critique";
    stmt.executeUpdate( SQLstr );
    stmt.close();
  
  }

  public static String escapeString( String str ) {

    StringBuffer result = new StringBuffer();
    for (int i=0; i < str.length(); i++) {
      if ( str.charAt(i) == 0 ) {
        result.append( "\\0" );
      } else if ( str.charAt(i) == 92 ) {
        result.append( "\\\\" );
      } else if ( str.charAt(i) == 39 ) {
        result.append( "\\\'" );
      } else if ( str.charAt(i) == 34 ) {
        result.append( "\\\"" );
      } else {
        result.append( str.charAt(i) );
      }
    }
    return result.toString();
  }
}
