package net.confidentialfiles.OpenReference;

import java.sql.*;
import java.util.*;
import net.confidentialfiles.DBUtils.*;

public class CategoryReference extends DatabaseTable {

  static public String TABLE = "CategoryReference";

  static public String[] FIELDS = new String[] {
    "CategoryID",
    "ReferenceID"
  };

  public CategoryReference() throws Exception {
  }

  static public boolean addRelation(Hashtable newRelation) throws Exception {

    DatabaseConn dbc = new DatabaseConn();
    Connection conn = dbc.getConn();

    insertRow(conn, TABLE, FIELDS, 
              newRelation);
    conn.close();
    return true;
  }

  static public int deleteRelationsForCategory(String CategoryID) throws Exception {

    DatabaseConn dbc = new DatabaseConn();
    Connection conn = dbc.getConn();

    int res = deleteRows(conn, TABLE, "CategoryID", CategoryID);
    conn.close();
    return res;
  }

  static public int deleteRelationsForReference(String ReferenceID) throws Exception {

    DatabaseConn dbc = new DatabaseConn();
    Connection conn = dbc.getConn();

    int res = deleteRows(conn, TABLE, "ReferenceID", ReferenceID);
    conn.close();
    return res;
  }

  static public Vector getCategories(String ReferenceID) throws Exception {
 
    DatabaseConn dbc = new DatabaseConn();
    Connection conn = dbc.getConn();

    Vector res = getEntries(conn, Category.TABLE, Category.FIELDS,
                      TABLE, "CategoryID", 
                      "ReferenceID", ReferenceID);
    conn.close();
    return res;
  }

  static public Vector getReferences(String CategoryID) throws Exception {

    DatabaseConn dbc = new DatabaseConn();
    Connection conn = dbc.getConn();

    Vector res = getEntries(conn, Reference.TABLE, Reference.FIELDS,
                      TABLE, "ReferenceID", 
                      "CategoryID", CategoryID);
     conn.close();
     return res;
  }

}

