package net.confidentialfiles.OpenReference;

import java.sql.*;
import java.util.*;
import net.confidentialfiles.DBUtils.*;

public class Comment extends DatabaseTable {

  static public String TABLE = "Comment";

  static public String[] FIELDS = new String[] {
    "CommentID",
    "UserID",
    "ReferenceID",
    "FatherCommentID",
    "NumberOfChildren",
    "CommentSubject",
    "Comment"
  };

  static public String[] SEARCH_FIELDS = new String[] {
    "Comment"
  };


  public Comment() throws Exception {
  }

  static public synchronized long addComment(Hashtable newComment) throws Exception {

    DatabaseConn dbc = new DatabaseConn();
    Connection conn = dbc.getConn();

    long newID = getMaxID(conn, TABLE, "CommentID") + 1;
    newComment.put("CommentID", (new Long(newID)).toString() );
    increaseChildrenCount( (String) newComment.get("FatherCommentID") );

    insertRow(conn, TABLE, FIELDS, newComment);
    conn.close();
    return newID;
  }

  static public boolean updateComment(Hashtable newValues) throws Exception {

    DatabaseConn dbc = new DatabaseConn();
    Connection conn = dbc.getConn();

    int n = updateRows(conn, TABLE, FIELDS, "CommentID", (String)newValues.get("CommentID"), newValues);
    conn.close();
    return n==1 ? true : false;
  }

  static public Hashtable getComment(String CommentID) throws Exception {

    DatabaseConn dbc = new DatabaseConn();
    Connection conn = dbc.getConn();

    Vector v = getRows(conn, TABLE, FIELDS, "CommentID", CommentID);
    conn.close();
    return (Hashtable) v.elementAt(0);
  }

  static public Vector getCommentsByReference(String ReferenceID) throws Exception {

    DatabaseConn dbc = new DatabaseConn();
    Connection conn = dbc.getConn();

    Vector v = getRows(conn, TABLE, FIELDS, "ReferenceID", ReferenceID);
    conn.close();
    return v;
  }

  static public Vector getCommentsByReferenceFatherComment(String ReferenceID, String FatherCommentID) throws Exception {

    DatabaseConn dbc = new DatabaseConn();
    Connection conn = dbc.getConn();

    String SQLstr = "SELECT * FROM " + TABLE + " WHERE ReferenceID = \'" +
                    ReferenceID + "\' AND FatherCommentID = \'" +
                    FatherCommentID + "\'";
    Statement stmt = conn.createStatement();
    ResultSet rs = stmt.executeQuery(SQLstr);

    Vector result = new Vector();
    while (rs.next()) {
      Hashtable entry = new Hashtable();
      for(int i=0; i<FIELDS.length; i++) {
        if ( rs.getString(FIELDS[i]) != null ) {
          entry.put(FIELDS[i], rs.getString(FIELDS[i]));
        }
      }
      result.add( entry );
    }
    rs.close();
    stmt.close();
    conn.close();
    return result;
  }

  static public Hashtable getUser(String ID) throws Exception {

    DatabaseConn dbc = new DatabaseConn();
    Connection conn = dbc.getConn();

    Vector v =  getEntries(conn, User.TABLE, User.FIELDS,
                           TABLE, "UserID", "ReferenceID", ID);
    conn.close();
    return (Hashtable) v.elementAt(0);
  }

  static public Vector search(String query) throws Exception {

    DatabaseConn dbc = new DatabaseConn();
    Connection conn = dbc.getConn();

    Vector res =  search(conn, TABLE, FIELDS, SEARCH_FIELDS, query);

    conn.close();
    return res;
  }

  static private void increaseChildrenCount(String CommentID) throws Exception {

    DatabaseConn dbc = new DatabaseConn();
    Connection conn = dbc.getConn();

    String SQLstr = "UPDATE " + TABLE + 
                    " SET NumberOfChildren = NumberOfChildren + 1" +
                    " WHERE CommentID = " + CommentID;
    Statement stmt = conn.createStatement();
    ResultSet rs = stmt.executeQuery(SQLstr);

    rs.close();
    stmt.close();
    conn.close();
    return;
  }

  static public int deleteAllChildren(String CommentID) throws Exception {

    DatabaseConn dbc = new DatabaseConn();
    Connection conn = dbc.getConn();

    String SQLstr = "DELETE FROM " + TABLE + " WHERE FatherCommentID = \'" +
                    CommentID + "\' OR CommentID = \'" +
                    CommentID + "\'";
    Statement stmt = conn.createStatement();
    int n = stmt.executeUpdate(SQLstr);

    stmt.close();
    conn.close();
    return n;
  }

  static public int deleteByReference(String ReferenceID) throws Exception {

    DatabaseConn dbc = new DatabaseConn();
    Connection conn = dbc.getConn();

    String SQLstr = "DELETE FROM " + TABLE + " WHERE ReferenceID = \'" +
                    ReferenceID + "\'";
    Statement stmt = conn.createStatement();
    int n = stmt.executeUpdate(SQLstr);

    stmt.close();
    conn.close();
    return n;
  }

  static public int deleteByUser(String UserID) throws Exception {

    DatabaseConn dbc = new DatabaseConn();
    Connection conn = dbc.getConn();

    String SQLstr = "DELETE FROM " + TABLE + " WHERE UserID = \'" +
                    UserID + "\'";
    Statement stmt = conn.createStatement();
    int n = stmt.executeUpdate(SQLstr);

    stmt.close();
    conn.close();
    return n;
  }
}

