package net.confidentialfiles.OpenReference;

import java.sql.*;

public class DatabaseConn implements DatabaseConnIntfc {

  private Connection conn;

  public DatabaseConn() {

    try {
      // explicitly register/load the given JDBC driver
      Class.forName(DRIVER);
    } catch (ClassNotFoundException e) {
      System.err.println("Failed to load DBC driver: " + DRIVER);
      System.err.println(e.getMessage());
      return;
    }

    try {
      // establish a connection to the given database URL
      conn = DriverManager.getConnection(URL, USER, PASSWORD);
    } catch (SQLException e) {
      System.err.println("Failed to connect to JDBC driver:" + URL);
      System.out.println("\n--- SQLException caught ---\n");
      while (e != null) {
        System.out.println("Message:   " + e.getMessage ());
        System.out.println("SQLState:  " + e.getSQLState ());
        System.out.println("ErrorCode: " + e.getErrorCode ());
        e = e.getNextException();
        System.out.println("");
      }
    }
  }

  public Connection getConn() {
    return conn;
  }

}
