package net.confidentialfiles.OpenReference;

import java.sql.*;
import java.util.*;
import net.confidentialfiles.DBUtils.*;

public class User extends DatabaseTable {

  static public String TABLE = "User";

  static public String[] FIELDS = new String[] {
    "UserID",
    "Username",
    "Password",
    "FirstName",
    "LastName",
    "Email",
    "Phone",
    "View",
    "UserList"
  };

  static public String[] SEARCH_FIELDS = new String[] {
    "Username",
    "FirstName",
    "LastName",
    "Email",
    "Phone"
  };

  public User() throws Exception {
  }

  static public synchronized long addUser(Hashtable newUser) throws Exception {

    DatabaseConn dbc = new DatabaseConn();
    Connection conn = dbc.getConn();

    long newID = getMaxID(conn, TABLE, "UserID") + 1;
    newUser.put("UserID", (new Long(newID)).toString() );

    insertRow(conn, TABLE, FIELDS, newUser);
    conn.close();
    return newID;
  }

  static public boolean updateUser(Hashtable newValues) throws Exception {

    DatabaseConn dbc = new DatabaseConn();
    Connection conn = dbc.getConn();

    int n = updateRows(conn, TABLE, FIELDS, "UserID", (String)newValues.get("UserID"), newValues);
    conn.close();
    return n==1 ? true : false;
  }

  static public Hashtable getUser(String ID) throws Exception {

    DatabaseConn dbc = new DatabaseConn();
    Connection conn = dbc.getConn();

    Vector v = getRows(conn, TABLE, FIELDS, "UserID", ID);
    conn.close();
    return (Hashtable) v.elementAt(0);
  }

  static public Vector getAllUsers() throws Exception {

    DatabaseConn dbc = new DatabaseConn();
    Connection conn = dbc.getConn();

    Vector res = getAllRows(conn, TABLE, FIELDS,
                      "Username", "ASC");
    conn.close();
    return res;
  }

  static public Vector getUsers(Vector ids) throws Exception {
    DatabaseConn dbc = new DatabaseConn();
    Connection conn = dbc.getConn();
    Statement stmt = conn.createStatement();

    Vector result = new Vector();
    for ( int i=0; i<ids.size(); i++ ) {
      String SQLstr = "SELECT * FROM " + TABLE + " WHERE UserID = \'" +
                      (String) ids.elementAt(i) + "\'";
      ResultSet rs = stmt.executeQuery(SQLstr);
      rs.next();
      Hashtable entry = new Hashtable();
      for(int j=0; j<FIELDS.length; j++) {
        if ( rs.getString(FIELDS[j]) != null ) {
          entry.put(FIELDS[j], rs.getString(FIELDS[j]));
        }
      }
      result.add( entry );
      rs.close();
    }
    stmt.close();
    conn.close();
    return result;
  }

  static public int deleteUser(String ID) throws Exception {

    DatabaseConn dbc = new DatabaseConn();
    Connection conn = dbc.getConn();

    int res = deleteRows(conn, TABLE, "UserID", ID);
    conn.close();
    return res;
  }

  static public boolean isAMemberOf(String username, String userlist) throws Exception {
    if (userlist == null) return false;
    StringTokenizer st = new StringTokenizer(userlist, ",", false);
    while (st.hasMoreTokens()) {
       if (username.equals(st.nextToken())) return true;
    }
    return false;
  }

  static public boolean isNameAvailable(String wantedname) throws Exception {

    DatabaseConn dbc = new DatabaseConn();
    Connection conn = dbc.getConn();

    return isNameAvailable( conn, TABLE, "Username", wantedname );
  }

}

