package net.confidentialfiles.DBUtils;

import java.util.*;

public class HTMLUtil {

  public static String textBox(String name, String value)
       throws Exception {

    StringBuffer result = new StringBuffer();
    if (name == null) throw new Exception("error in HTMLUtil, textBox!");
    if (value == null) {
      result.append("<input type=text size=10 name=\"" + name + "\">");
    } else {
      result.append("<input type=text size=10 name=\"" + name + 
                    "\" value=\"" + value + "\">");
    }
    return result.toString();
  }

  public static String textareaBox(String name, String value)
       throws Exception {

    StringBuffer result = new StringBuffer();
    if (name == null) throw new Exception("error in HTMLUtil, textareaBox!");
    if (value == null) {
      result.append("<textarea rows=8 cols=40 name=\"" + name + 
                    "\"></textarea>");
    } else {
      result.append("<textarea rows=8 cols=40 name=\"" + name + 
                    "\">" + value + "</textarea>");
    }
    return result.toString();
  }

  public static String checkBox(String name, String value, boolean checked)
       throws Exception {

    StringBuffer result = new StringBuffer();
    if (name == null) throw new Exception("error in HTMLUtil, checkBox!");
    if (value == null) {
      if ( checked ) {
        result.append("<input type=checkbox name=\"" + name +
                      "\" value=\"null\" checked>");
      } else {
        result.append("<input type=checkbox name=\"" + name +
                      "\" value=\"null\">");
      }
    } else {
      if ( checked ) {
        result.append("<input type=checkbox name=\"" + name +
                      "\" value=\"" + value + "\" checked>");
      } else {
        result.append("<input type=checkbox name=\"" + name +
                      "\" value=\"" + value + "\">");
      }
    }
    return result.toString();
  }

  public static String radioButton(String name, String value, boolean checked)
       throws Exception {

    StringBuffer result = new StringBuffer();
    if (name == null) throw new Exception("error in HTMLUtil, radioBox!");
    if (value == null) {
      if ( checked ) {
        result.append("<input type=radio name=\"" + name +
                      "\" value=\"null\" checked>");
      } else {
        result.append("<input type=radio name=\"" + name +
                      "\" value=\"null\">");
      }
    } else {
      if ( checked ) {
        result.append("<input type=radio name=\"" + name +
                      "\" value=\"" + value + "\" checked>");
      } else {
        result.append("<input type=radio name=\"" + name +
                      "\" value=\"" + value + "\">");
      }
    }
    return result.toString();
  }


  public static String selectMenu(String name, String value, String[] valueOptions, String[] options)
       throws Exception {
    // if the dropdown box does not have specfic value (null)
    // it wll default to the "null" string

    StringBuffer result = new StringBuffer();
    if (name == null) throw new Exception("error in HTMLUtil, dropdownManu!");
    if (valueOptions.length != options.length) 
         throw new Exception("error in HTMLUtil, dropdownManu!");
    int size = valueOptions.length;

    if (value == null) {
      result.append("<select name=\"" + name + "\">");
      for ( int i=0; i<size; i++ ) {
        if ( "null".equals(valueOptions[i]) ) {
          result.append("<option value=\"" + valueOptions[i] + 
                        "\" SELECTED>" + options[i] );
        } else {
          result.append("<option value=\"" + valueOptions[i] + 
                        "\">" + options[i] );
        }
      }
      result.append("</select>");
    } else {
      result.append("<select name=\"" + name + "\">");
      for ( int i=0; i<size; i++ ) {
        if ( value.equals(valueOptions[i]) ) {
          result.append("<option value=\"" + valueOptions[i] + 
                        "\" SELECTED>" + options[i] );
        } else {
          result.append("<option value=\"" + valueOptions[i] + 
                        "\">" + options[i] );
        }
      }
      result.append("</select>");
    }
    return result.toString();
  }

  public static void processInput(Hashtable h)
       throws Exception {

  // This function detects String "null" in values and then replace them
  // with null obj. We can prevent them from getting into the SQL string
  // this way. We cannot just delete them from Hashtable since the update
  // would not function correctly ...

    Object o;
    NullValue nv = new NullValue();
    for (Enumeration e = h.keys(); e.hasMoreElements(); ) {
      o = e.nextElement();
      String s = (String)h.get(o);
      if ( !isStr(s) ) {
//        h.remove(o);
        h.put(o, nv);
      } else {
        h.put(o, DatabaseUtil.escapeString(s));
      }
    }
    return;
  }

  public static void processInput(Hashtable h, String mode)
       throws Exception {

  // This function detects String "null" in values and then replace them
  // with null obj. We can prevent them from getting into the SQL string
  // this way. We cannot just delete them from Hashtable since the update
  // would not function correctly ...

    Object o;
    NullValue nv = new NullValue();
    for (Enumeration e = h.keys(); e.hasMoreElements(); ) {
      o = e.nextElement();
      String s = (String)h.get(o);
      if ( !isStr(s) ) {
//        h.remove(o);
        h.put(o, nv);
      } else {
        h.put(o, DatabaseUtil.escapeString(s, mode));
      }
    }
    return;
  }

  public static String fixNullString(String s)
       throws Exception {
    if ( s == null ) {
      return "";
    } else {
/***********Something we do not want to ****************
      String newStr = "";
      for (int i=0; i<s.length(); i++) {
        if ( s.charAt(i) == '\"' ) {
          newStr += "\\\"";
        } else if ( s.charAt(i) == '>' ) {
          newStr += "&gt;";
        } else if ( s.charAt(i) == '<' ) {
          newStr += "&lt;";
        } else {
          newStr += s.charAt(i);
        }
      }
      return newStr;
*********************************************************/
      return s;
    }
  }

  public static boolean isStr(String s) throws Exception {
    if ( s == null ) return false;
    if ( s.length() == 0 ) return false;
    if ( "null".equals(s) ) return false;
    if ( "NULL".equals(s) ) return false;
    for (int i=0; i<s.length(); i++) {
      if ( s.charAt(i) != ' ' ) {
        return true;
      }
    }
    return false;
  }

}
